<template>
  <div class="container-fluid">
    <div class="card mt-5">
        <div class="card-header">
            <span style="font-size: 20px;">Roles</span>
              <router-link exact-active-class="active" :to="{ name: 'roles'}" :class="['btn btn-outline-primary pull-right mt-1']">
                  Atras
              </router-link> 
        </div>
        <div class="card-body">
          <form class="form-horizontal">
            <div class="form-group row" >
                <label class="col-md-3 form-control-label" for="text-input">Nombre</label>
                <div class="col-md-9">
                    <input type="text" v-model="role.name" class="form-control" placeholder="Nombre" >
                    <span v-if="allerrors.name" :class="['text-danger']">{{ allerrors.name[0] }}</span>
                </div>
            </div>
            
            <div class="form-group row" >
                <label class="col-md-3 form-control-label" for="text-input">Permisos</label>
                <div class="col-md-9">
                    <table  class="table table-hover">
                        <thead>
                            <tr>
                                <th>Permisos</th>
                                <th></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr  v-for="(permission,index) in permissions" :key="index" >
                                <td >{{permission.name}}</td>
                                <td style="width:30px;"><input type="checkbox" v-model="role.permissions_id" :value="permission.id"></td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
          </form>
          <div class="modal-footer">
            <button v-if="!role.id" type="button" @click="create()" class="btn btn-primary">Crear</button>
            <button v-if="role.id" type="button" @click="update()" class="btn btn-primary">Actualizar</button>
          </div>
        </div>
    </div>
  </div>
</template>

<script>

export default {
  data() {
    return {
      allerrors: {},
      permissions:[],
      role: {
        name: null,
        permissions_id: [],
      },
    };
  },
   
     
  methods: {
    getShowRole() {
      let _this = this;
      axios
        .get("/admin/role/show/" + _this.$route.params.id)
        .then(function(response) {
          
          _this.role = response.data;
          _this.permissions_id = response.data.permissions_id;
          
          console.log(_this.role);
        });
    },
    getPermissions(){
      let _this = this;
      axios .get("/admin/permissions")
      .then(function(response) {
        _this.permissions = response.data;
      });

    },
    create() {
      let _this = this;
      axios
        .post("/admin/role", _this.role)
        .then(function(response) {
          _this.allerrors = [];
          _this.$message.success("Se ha creado el rol con exito.");
          _this.$router.push({ name: "roles" });
        })
        .catch(function(error) {
          if (error.response && error.response.data) {
            _this.$message.error(
              "Ha ocurrido un error, verifique los campos del formulario."
            );
            _this.allerrors = error.response.data.errors;
          } else {
            console.log("error RoleFormComponent update", error);
          }
        });
    },
    update() {
      let _this = this;

      axios
        .put("/admin/role/"+ _this.$route.params.id, _this.role)
        .then(function(response) {
          _this.allerrors = [];
          _this.$message.success("Se ha actualizado el rol con exito.");
          _this.$router.push({ name: "roles" });
        })
        .catch(function(error) {
          if (error.response && error.response.data) {
            _this.$message.error(
              "Ha ocurrido un error, verifique los campos del formulario."
            );
            _this.allerrors = error.response.data.errors;
          } else {
            console.log("error RoleFormComponent update", error);
          }
        });
    }
  },
  mounted() {
    if (this.$route.params.id > 0) {
      this.getShowRole()
    }
    this.getPermissions();
  }
};
</script>